/*$Id: acre_bcast_vector.c,v 1.1 2004/04/30 J. Malard Exp d3j540 $ */

#include "tao_solver.h"
#include "petscblaslapack.h"
#include "petsclog.h"
#include "acre.h"
#include "petsclog.h"
#include <assert.h>
#include <mpi.h>
#include <math.h>
#include "copyright.h"
#undef __FUNC__
#define __FUNC__ "acre_bcast_vector"
int acre_bcast_vector(Vec iVec, Vec iSeq)
{
	/*
	 * broadcast a distributed vector: used in acre_detl.
	 */
	int ierr, nq;
	IS iS;
	IS jS;
	VecScatter iScatter;

	HELLO("acre_bcast_vector enter");
	ierr = VecGetSize(iVec, &nq);
	ierr = ISCreateStride(PETSC_COMM_SELF, nq, 0, 1, &iS);	CHKERRQ(ierr);
	ierr = ISCreateStride(PETSC_COMM_SELF, nq, 0, 1, &jS);	CHKERRQ(ierr);
	ierr = VecScatterCreate(iVec, iS, iSeq, jS, &iScatter);	CHKERRQ(ierr);
	ierr = ISDestroy(iS);					CHKERRQ(ierr);
	ierr = ISDestroy(jS);					CHKERRQ(ierr);

	ierr = VecScatterBegin ( iVec, iSeq, INSERT_VALUES,
		SCATTER_FORWARD, iScatter );			CHKERRQ(ierr);
	ierr = VecScatterEnd ( iVec, iSeq, INSERT_VALUES,
		SCATTER_FORWARD, iScatter );			CHKERRQ(ierr);
	ierr = VecScatterDestroy( iScatter);			CHKERRQ(ierr);

	HELLO("acre_bcast_vector exit");
	return 0;
}
