/* $Id: acre_detl.c,v 1.1 2004/04/30 05:15:40 Joel M. Malard Exp d3j540 $ */

#include "tao_solver.h"
#include "petscblaslapack.h"
#include "petsclog.h"
#include "acre.h"
#include "petsclog.h"
#include <assert.h>
#include <mpi.h>
#include "copyright.h"
#undef __FUNC__
#define __FUNC__ "acre_detl"
int acre_detl(Mat sL, Vec sLDiag)
{
	int m, nq;
	int irow, nrows;
	int start, end;
	int h, i, j, k, ierr;
	int ncols, *cols;
	PetscScalar *vals, zero=0.0, one=1.0;
	Vec x;

	HELLO("acre_detl enter");
	ierr = MatGetSize ( sL, &m, &nq );			CHKERRQ(ierr);
	ierr = MatGetOwnershipRange ( sL, &start, &end );	CHKERRQ(ierr);
	ierr = VecCreateMPI(PETSC_COMM_WORLD, PETSC_DECIDE,
		nq, &x);					CHKERRQ(ierr);
	ierr = VecSet( &zero, x);				CHKERRQ(ierr);

	nrows = end-start;
	for ( i=0; i<nrows; i++ )
	{
		irow = i+start;
		ierr = MatGetRow ( sL, irow, &ncols, &cols,
			&vals );				CHKERRQ(ierr);
		for ( j=0; j<ncols; j++ )
		{
			h = ((int)vals[j])-1;
			k = cols[j];
			if(h==irow)
			{
				VecSetValue (x, k, one,
					ADD_VALUES);		CHKERRQ(ierr);
			}
		}
		ierr = MatRestoreRow( sL, irow, &ncols,
			&cols, &vals);				CHKERRQ(ierr);
	}
	ierr = VecAssemblyBegin(x);				CHKERRQ(ierr);
	ierr = VecAssemblyEnd(x);				CHKERRQ(ierr);

	ierr = acre_bcast_vector(x, sLDiag);			CHKERRQ(ierr);

	ierr = VecDestroy( x);					CHKERRQ(ierr);

	HELLO("acre_detl exit");

	return 0;

}
