/*$Id: acre_print_aij_matrix_serial.c,v 1.1 2004/04/30 J. Malard Exp d3j540 $*/

#include <stdlib.h>
#include <assert.h>
#include "tao.h"
#include "acre.h"
#include "petscmat.h" 
#include "copyright.h"
#undef __FUNC__
#define __FUNC__ "acre_print_aij_matrix_serial"

int acre_print_aij_matrix_serial(Mat A, char * infile, PetscTruth format)
{
	int ierr;
	PetscViewer  fd;

	HELLO("acre_print_aij_matrix_serial enter");

	if ( format==PETSC_TRUE )
	{
		int i, j, *cols;
		int m, n, nc;
		int rs, re;
		PetscScalar *vals;
		ierr = MatGetOwnershipRange( A, &rs, &re);	CHKERRQ(ierr);
		ierr = MatGetSize( A, &m, &n);			CHKERRQ(ierr);

		ierr = PetscViewerASCIIOpen(PETSC_COMM_SELF,
			infile, &fd);				CHKERRQ(ierr);
		PetscViewerASCIIPrintf(fd,"%d\t%d\n",m,n);
		for ( i=rs; i<re; i++ )
		{
			ierr = MatGetRow( A, i, &nc, &cols,
				&vals);				CHKERRQ(ierr);
			for ( j=0; j<nc; j++ )
			{
				PetscViewerASCIIPrintf(fd,
					"%d\t%d\t%lg\n",
					i,cols[j],vals[j]);
			}
			ierr = MatRestoreRow( A, i,
				&nc, &cols, &vals);		CHKERRQ(ierr);
		}
		ierr = PetscViewerDestroy(fd);			CHKERRQ(ierr);
	}
	else
	{
		ierr = PetscViewerBinaryOpen(PETSC_COMM_SELF,
			infile, PETSC_FILE_CREATE,&fd);		CHKERRQ(ierr);
		ierr = MatView(A, fd);				CHKERRQ(ierr);
		ierr = PetscViewerDestroy(fd);			CHKERRQ(ierr);
	}

	HELLO("acre_print_aij_matrix_serial exit");

	return ierr;
}
